unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, ComCtrls, CWMIBase, CWMISQL, OI,
  ImgList, Grids, ValEdit;

type
  TFormMain = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    pnlTitle: TPanel;
    imgComponent: TImage;
    lblTitle: TLabel;
    WMISQL: TWMISQL;
    Panel2: TPanel;
    Label15: TLabel;
    Splitter1: TSplitter;
    ImageList1: TImageList;
    vleProcesos: TValueListEditor;
    Panel3: TPanel;
    edtSQL: TEdit;
    mmVal: TMemo;
    btnExecute: TButton;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure btnExecuteClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    _actual:Integer;
    // Rellenar las Claves-Valor
    procedure FillValues();

  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}


procedure TFormMain.btnExecuteClick(Sender: TObject);
begin
  WMISQL.Active := False;
  WMISQL.SQL := edtSQL.Text;

  // Activar
  WMISQL.Active := True;

  _actual := WMISQL.ObjectIndex;

  // Cargar valores
  mmVal.Lines.Text := WMISQL.AllProperties.Text;

  FillValues();

  // Hay varios? visualizamos el panel de navegacin
  if (WMISQL.ObjectsCount > 1) then begin
    Panel4.Visible := (WMISQL.ObjectsCount > 1);
    label2.Caption := Format('Se han encontrado %d elementos',[WMISQL.ObjectsCount]);
  end;

end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  if (WMISQL.ObjectsCount > 1) and (_actual > 1) then begin
    WMISQL.ObjectIndex := _actual - 1;
    _actual := WMISQL.ObjectIndex;
    FillValues();
  end;
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  if (WMISQL.ObjectsCount > _actual) then begin
    WMISQL.ObjectIndex := _actual + 1;
    _actual := WMISQL.ObjectIndex;

    FillValues();
  end;

end;

procedure TFormMain.FillValues;
begin

  vleProcesos.Strings.Clear;
  vleProcesos.Strings.AddStrings(WMISQL.Properties);

  label3.Caption := Format('Elemento <%d> de  <%d>',[_actual, WMISQL.ObjectsCount]);

end;

end.
