unit UTAboutProp;

//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  DesignIntf, DesignEditors;

type
  TAboutGlibWMIProp = class(TPropertyEditor)
  public
    procedure Edit(); override;
    function GetValue(): string; override;
    function GetAttributes(): TPropertyAttributes; override;
  end;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

uses
  {$IF CompilerVersion >= 16.0}
  System.SysUtils,
  {$ELSE}
  SysUtils,
  {$IFEND}
  FormAbout, UConstantes;

procedure TAboutGlibWMIProp.Edit();
begin
  with TFAbout.Create(nil) do
  try
    ShowModal();
  finally
    Free();
  end;
end;

function TAboutGlibWMIProp.GetValue(): string;
begin
  result := Format(GLIBSI_LBL,[GLIBSI_VERSION]);
  result := GLIBSI_VERSION;
end;

function TAboutGlibWMIProp.GetAttributes(): TPropertyAttributes;
begin
  result := [paDialog,paReadOnly];
end;

end.
